Index: squid/src/access_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/access_log.c,v
retrieving revision 1.1.1.3.12.7.2.4
retrieving revision 1.1.1.3.12.7.2.5
diff -u -r1.1.1.3.12.7.2.4 -r1.1.1.3.12.7.2.5
--- squid/src/access_log.c	6 Jan 2001 22:51:16 -0000	1.1.1.3.12.7.2.4
+++ squid/src/access_log.c	7 Jan 2001 09:48:30 -0000	1.1.1.3.12.7.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: access_log.c,v 1.1.1.3.12.7.2.4 2001/01/06 22:51:16 rbcollins Exp $
+ * $Id: access_log.c,v 1.1.1.3.12.7.2.5 2001/01/07 09:48:30 hno Exp $
  *
  * DEBUG: section 46    Access Log
  * AUTHOR: Duane Wessels
@@ -191,9 +191,9 @@
     char *buf;
     char *buf_cursor;
     if (header == NULL) {
-        buf = xcalloc(1, 1);
-        *buf = '\0';
-        return buf;
+	buf = xcalloc(1, 1);
+	*buf = '\0';
+	return buf;
     }
     buf = xcalloc((strlen(header) * 3) + 1, 1);
     buf_cursor = buf;
@@ -202,23 +202,22 @@
      * to prevent garbage in the logs. CR and LF are also there just in case. 
      */
     while ((c = *(const unsigned char *) header++) != '\0') {
-        if (c == '\r') {
-            *buf_cursor++ = '\\';
-            *buf_cursor++ = 'r';
-        } else if (c == '\n') {
-            *buf_cursor++ = '\\';
-            *buf_cursor++ = 'n';
-        } else
-            if (c <= 0x1F
-                || c >= 0x7F
-            || c == ' ') {
-            *buf_cursor++ = '%';
-            i = c * 2;
-            *buf_cursor++ = c2x[i];
-            *buf_cursor++ = c2x[i + 1];
-        } else {
-            *buf_cursor++ = (char) c;
-        }
+	if (c == '\r') {
+	    *buf_cursor++ = '\\';
+	    *buf_cursor++ = 'r';
+	} else if (c == '\n') {
+	    *buf_cursor++ = '\\';
+	    *buf_cursor++ = 'n';
+	} else if (c <= 0x1F
+		|| c >= 0x7F
+	    || c == ' ') {
+	    *buf_cursor++ = '%';
+	    i = c * 2;
+	    *buf_cursor++ = c2x[i];
+	    *buf_cursor++ = c2x[i + 1];
+	} else {
+	    *buf_cursor++ = (char) c;
+	}
     }
     *buf_cursor = '\0';
     return buf;
@@ -228,7 +227,7 @@
 accessLogFormatName(const char *name)
 {
     if (NULL == name)
-        return xcalloc(strlen(dash_str)+1,1);
+	return xcalloc(strlen(dash_str) + 1, 1);
     return username_quote(name);
 }
 
@@ -236,7 +235,7 @@
 accessLogSquid(AccessLogEntry * al)
 {
     const char *client = NULL;
-    char * user =NULL;
+    char *user = NULL;
     if (Config.onoff.log_fqdn)
 	client = fqdncache_gethostbyaddr(al->cache.caddr, FQDN_LOOKUP_IF_MISS);
     if (client == NULL)
@@ -251,8 +250,8 @@
 	al->cache.size,
 	al->private.method_str,
 	al->url,
-	(user=accessLogFormatName(al->cache.authuser ? 
-            al->cache.authuser : al->cache.rfc931)),
+	(user = accessLogFormatName(al->cache.authuser ?
+		al->cache.authuser : al->cache.rfc931)),
 	al->hier.ping.timedout ? "TIMEOUT_" : "",
 	hier_strings[al->hier.code],
 	al->hier.host,
@@ -264,7 +263,7 @@
 accessLogCommon(AccessLogEntry * al)
 {
     const char *client = NULL;
-    char * user =NULL;
+    char *user = NULL;
     if (Config.onoff.log_fqdn)
 	client = fqdncache_gethostbyaddr(al->cache.caddr, 0);
     if (client == NULL)
@@ -272,7 +271,7 @@
     logfilePrintf(logfile, "%s %s %s [%s] \"%s %s HTTP/%d.%d\" %d %d %s:%s",
 	client,
 	accessLogFormatName(al->cache.rfc931),
-        (user=accessLogFormatName(al->cache.authuser)),
+	(user = accessLogFormatName(al->cache.authuser)),
 	mkhttpdlogtime(&squid_curtime),
 	al->private.method_str,
 	al->url,
Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.1.1.3.12.26.2.22
retrieving revision 1.1.1.3.12.26.2.23
diff -u -r1.1.1.3.12.26.2.22 -r1.1.1.3.12.26.2.23
--- squid/src/acl.c	7 Jan 2001 00:37:02 -0000	1.1.1.3.12.26.2.22
+++ squid/src/acl.c	7 Jan 2001 09:48:30 -0000	1.1.1.3.12.26.2.23
@@ -1,6 +1,6 @@
 
 /*
- * $Id: acl.c,v 1.1.1.3.12.26.2.22 2001/01/07 00:37:02 hno Exp $
+ * $Id: acl.c,v 1.1.1.3.12.26.2.23 2001/01/07 09:48:30 hno Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -649,28 +649,29 @@
 {
 /*  This code currently non-functional */
 /*
-    acl_proxy_auth_data *pad;
-    char *t = NULL;
- 
-    pad = memAllocate(MEM_ACL_PROXY_AUTH_DATA);
-    pad->names = NULL;
-    *(acl_proxy_auth_data **)curlist = pad;
-    t = strtokFile();
-
-    if (!strcmp(t, "basic"))
-        pad->type = AUTH_BASIC;
-    else if (!strcmp(t, "ntlm"))
-        pad->type = AUTH_NTLM;
-    else {
-	debug(28, 0) ("%s line %d: %s\n",
-	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseProxyAuthList: Invalid auth type '%s'\n", t);
-	return;
-    }
-    while ((t = strtokFile()))
-	wordlistAdd(&pad->names, t);
-*/
+ * acl_proxy_auth_data *pad;
+ * char *t = NULL;
+ * 
+ * pad = memAllocate(MEM_ACL_PROXY_AUTH_DATA);
+ * pad->names = NULL;
+ * *(acl_proxy_auth_data **)curlist = pad;
+ * t = strtokFile();
+ * 
+ * if (!strcmp(t, "basic"))
+ * pad->type = AUTH_BASIC;
+ * else if (!strcmp(t, "ntlm"))
+ * pad->type = AUTH_NTLM;
+ * else {
+ * debug(28, 0) ("%s line %d: %s\n",
+ * cfg_filename, config_lineno, config_input_line);
+ * debug(28, 0) ("aclParseProxyAuthList: Invalid auth type '%s'\n", t);
+ * return;
+ * }
+ * while ((t = strtokFile()))
+ * wordlistAdd(&pad->names, t);
+ */
 }
+
 #endif
 
 /**********************/
@@ -784,30 +785,30 @@
 	aclParseMethodList(&A->data);
 	break;
     case ACL_PROXY_AUTH:
-        if (authenticateSchemeCount()==0) {
-            debug(28,0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
-because no authentication schemes were compiled.\n",A->cfgline);
-        } else if (authenticateActiveSchemeCount()==0) {
-            debug(28,0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
-because no authentication schemes are fully configured.\n",A->cfgline);
-        } else {
+	if (authenticateSchemeCount() == 0) {
+	    debug(28, 0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
+because no authentication schemes were compiled.\n", A->cfgline);
+	} else if (authenticateActiveSchemeCount() == 0) {
+	    debug(28, 0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
+because no authentication schemes are fully configured.\n", A->cfgline);
+	} else {
 #if 0
-            aclParseProxyAuthList(&A->data);
+	    aclParseProxyAuthList(&A->data);
 #else
-            aclParseWordList(&A->data);
+	    aclParseWordList(&A->data);
 #endif
-        } 
+	}
 	break;
     case ACL_PROXY_AUTH_REGEX:
-        if (authenticateSchemeCount()==0) {
-            debug(28,0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
-because no authentication schemes were compiled.\n",A->cfgline);
-        } else if (authenticateActiveSchemeCount()==0) {
-            debug(28,0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
-because no authentication schemes are fully configured.\n",A->cfgline);
-        } else {
+	if (authenticateSchemeCount() == 0) {
+	    debug(28, 0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
+because no authentication schemes were compiled.\n", A->cfgline);
+	} else if (authenticateActiveSchemeCount() == 0) {
+	    debug(28, 0) ("aclParseAclLine: IGNORING: Proxy Auth ACL '%s' \
+because no authentication schemes are fully configured.\n", A->cfgline);
+	} else {
 	    aclParseRegexList(&A->data);
-        }
+	}
 	break;
 #if SQUID_SNMP
     case ACL_SNMP_COMMUNITY:
@@ -1066,7 +1067,7 @@
     while (data) {
 	debug(28, 3) ("aclMatchUser: looking for '%s'\n", data->key);
 	if (strcmp(data->key, "REQUIRED") == 0 && *user != '\0'
-            && strcmp(user, dash_str) != 0)
+	    && strcmp(user, dash_str) != 0)
 	    return 1;
 	if (strcmp(data->key, user) == 0)
 	    return 1;
@@ -1117,8 +1118,8 @@
     case ACL_PROXY_AUTH_REGEX:
 	matchrv = aclMatchRegex(data, MatchParam);
     default:
-        /* This is a fatal to ensure that aclCacheMatchAcl calls are _only_
-         * made for supported acl types */
+	/* This is a fatal to ensure that aclCacheMatchAcl calls are _only_
+	 * made for supported acl types */
 	fatal("aclCacheMatchAcl: unknown or unexpected ACL type");
 	return 0;		/* NOTREACHED */
     }
@@ -1130,16 +1131,17 @@
 }
 
 void
-aclCacheMatchFlush(dlink_list * cache) {
+aclCacheMatchFlush(dlink_list * cache)
+{
     acl_proxy_auth_match_cache *auth_match;
     dlink_node *link, *tmplink;
-    link=cache->head;
+    link = cache->head;
     while (link) {
-        auth_match = link->data;
-        tmplink=link;
-        link=link->next;
-        dlinkDelete(tmplink, cache);
-        memFree(auth_match, MEM_ACL_PROXY_AUTH_MATCH);
+	auth_match = link->data;
+	tmplink = link;
+	link = link->next;
+	dlinkDelete(tmplink, cache);
+	memFree(auth_match, MEM_ACL_PROXY_AUTH_MATCH);
     }
 }
 
@@ -1154,7 +1156,7 @@
     auth_user_request_t * auth_user_request, aclCheck_t * checklist, squid_acl acltype)
 {
     /* checklist is used to register user name when identified, nothing else */
-    const char * proxy_auth;
+    const char *proxy_auth;
     /* consistent parameters ? */
     assert(auth_user_request == checklist->auth_user_request);
 
@@ -1172,109 +1174,106 @@
 	debug(28, 1) ("aclMatchProxyAuth: no connection data, cannot process authentication\n");
 	/*
 	 * deny access: clientreadrequest requires conn data, and it is always
-         * compiled in so we should have it too.
+	 * compiled in so we should have it too.
 	 */
 	return 0;
     }
-    if (((proxy_auth == NULL) && (checklist->conn->auth_type==AUTH_UNKNOWN)) || (checklist->conn->auth_type == AUTH_BROKEN)) {
+    if (((proxy_auth == NULL) && (checklist->conn->auth_type == AUTH_UNKNOWN)) || (checklist->conn->auth_type == AUTH_BROKEN)) {
 	/* no header or authentication failed/got corrupted - restart */
 	checklist->conn->auth_type = AUTH_UNKNOWN;
-	debug(28,4) ("aclMatchProxyAuth: broken auth or no proxy_auth header. Requesting auth header.\n");
+	debug(28, 4) ("aclMatchProxyAuth: broken auth or no proxy_auth header. Requesting auth header.\n");
 	/* something wrong with the AUTH credentials. Force a new attempt */
 	checklist->auth_user_request = NULL;
-        checklist->conn->auth_user_request = NULL;
+	checklist->conn->auth_user_request = NULL;
 	if (auth_user_request) {
-            /* unlock the ACL lock */
-            authenticateAuthUserRequestUnlock(auth_user_request);
-        }
+	    /* unlock the ACL lock */
+	    authenticateAuthUserRequestUnlock(auth_user_request);
+	}
 	return -2;
     }
     /* we have a proxy auth header and as far as we know this connection has
      * not had bungled connection oriented authentication happen on it. */
-    debug(28,9) ("aclMatchProxyAuth: header %s.\n", proxy_auth);
+    debug(28, 9) ("aclMatchProxyAuth: header %s.\n", proxy_auth);
     if (auth_user_request == NULL) {
-        debug(28,9) ("aclMatchProxyAuth: This is a new request on FD:%d\n", checklist->conn->fd);
-        if ((!checklist->request->auth_user_request) && (checklist->conn->auth_type==AUTH_UNKNOWN )) {
-            /* beginning of a new request check */
-            debug(28,4)("aclMatchProxyAuth: no connection authentication type\n");
-            if (!authenticateValidateUser(auth_user_request=authenticateGetAuthUser(proxy_auth)))
-            {
-                /* the decode might have left a username for logging, or a message to
-                 * the user */
-                if (auth_user_request)
-                {
-                    /* lock the user for the request structure link */
-                    authenticateAuthUserRequestLock(auth_user_request);
-                    checklist->request->auth_user_request=auth_user_request;
-                    /* unlock the ACL reference.*/
-                    authenticateAuthUserRequestUnlock(auth_user_request);
-                }
-                return -2;
-             } 
-             /* the user_request comes prelocked for the caller to GetAuthUser (us) */
-        } else if (checklist->request->auth_user_request) {
-            auth_user_request=checklist->request->auth_user_request;
-            /* lock the user request for this ACL processing */
-            authenticateAuthUserRequestLock(auth_user_request);
-        } else {
-            if (checklist->conn->auth_user_request != NULL) {
-                auth_user_request=checklist->conn->auth_user_request;
-                /* lock the user request for this ACL processing */
-                authenticateAuthUserRequestLock(auth_user_request);
-            } else {
-                /* failed connection based authentication */
-                debug(28,4)("aclMatchProxyAuth: Aauth user request %d conn-auth user request %d conn type %d authentication failed.\n",auth_user_request, checklist->conn->auth_user_request,checklist->conn->auth_type);
-                return -2;
-            }
-        }
+	debug(28, 9) ("aclMatchProxyAuth: This is a new request on FD:%d\n", checklist->conn->fd);
+	if ((!checklist->request->auth_user_request) && (checklist->conn->auth_type == AUTH_UNKNOWN)) {
+	    /* beginning of a new request check */
+	    debug(28, 4) ("aclMatchProxyAuth: no connection authentication type\n");
+	    if (!authenticateValidateUser(auth_user_request = authenticateGetAuthUser(proxy_auth))) {
+		/* the decode might have left a username for logging, or a message to
+		 * the user */
+		if (auth_user_request) {
+		    /* lock the user for the request structure link */
+		    authenticateAuthUserRequestLock(auth_user_request);
+		    checklist->request->auth_user_request = auth_user_request;
+		    /* unlock the ACL reference. */
+		    authenticateAuthUserRequestUnlock(auth_user_request);
+		}
+		return -2;
+	    }
+	    /* the user_request comes prelocked for the caller to GetAuthUser (us) */
+	} else if (checklist->request->auth_user_request) {
+	    auth_user_request = checklist->request->auth_user_request;
+	    /* lock the user request for this ACL processing */
+	    authenticateAuthUserRequestLock(auth_user_request);
+	} else {
+	    if (checklist->conn->auth_user_request != NULL) {
+		auth_user_request = checklist->conn->auth_user_request;
+		/* lock the user request for this ACL processing */
+		authenticateAuthUserRequestLock(auth_user_request);
+	    } else {
+		/* failed connection based authentication */
+		debug(28, 4) ("aclMatchProxyAuth: Aauth user request %d conn-auth user request %d conn type %d authentication failed.\n", auth_user_request, checklist->conn->auth_user_request, checklist->conn->auth_type);
+		return -2;
+	    }
+	}
     }
-       
     /* Clear the reference in the checklist */
     checklist->auth_user_request = NULL;
-    if (!authenticateUserAuthenticated(auth_user_request)){
-        /* User not logged in. Log them in */
+    if (!authenticateUserAuthenticated(auth_user_request)) {
+	/* User not logged in. Log them in */
 #if 0
-        /* if they have not got an IP already give them one */
-        if (!auth_user->ipaddr.s_addr) 
-            auth_user->ipaddr = checklist->src_addr;
-#endif
-        authenticateAuthUserRequestSetIp(auth_user_request, checklist->src_addr);
-        authenticateAuthenticateUser(auth_user_request, checklist->request, checklist->conn,headertype);
-        switch (authenticateDirection(auth_user_request)) {
-            case 1:
-                /* this ACL check is finished. Unlock. */
-                authenticateAuthUserRequestUnlock(auth_user_request);
-                return -2;
-            case -1:
-                /* we are partway through authentication within squid
-                 * store the auth_user for the callback to here */
-                checklist->auth_user_request=auth_user_request;
-                /* we will be called back here. Do not Unlock */
-                return -1;
-            case -2:
-                /* this ACL check is finished. Unlock. */
-                authenticateAuthUserRequestUnlock(auth_user_request);
-                return -2;
-        } /* on 0 the authentication is finished - fallthrough */
-        /* See of user authentication failed for some reason */
-        if (!authenticateUserAuthenticated(auth_user_request)) {
-            if ((!checklist->rfc931[0]) && 
-                (authenticateUserRequestUsername(auth_user_request))) {
-                if (!checklist->request->auth_user_request) {
-                    /* lock the user for the request structure link */
-                    authenticateAuthUserRequestLock(auth_user_request);
-                    checklist->request->auth_user_request=auth_user_request;
-                }
-            }
-            /* this ACL check is finished. Unlock. */
-            authenticateAuthUserRequestUnlock(auth_user_request);
+	/* if they have not got an IP already give them one */
+	if (!auth_user->ipaddr.s_addr)
+	    auth_user->ipaddr = checklist->src_addr;
+#endif
+	authenticateAuthUserRequestSetIp(auth_user_request, checklist->src_addr);
+	authenticateAuthenticateUser(auth_user_request, checklist->request, checklist->conn, headertype);
+	switch (authenticateDirection(auth_user_request)) {
+	case 1:
+	    /* this ACL check is finished. Unlock. */
+	    authenticateAuthUserRequestUnlock(auth_user_request);
+	    return -2;
+	case -1:
+	    /* we are partway through authentication within squid
+	     * store the auth_user for the callback to here */
+	    checklist->auth_user_request = auth_user_request;
+	    /* we will be called back here. Do not Unlock */
+	    return -1;
+	case -2:
+	    /* this ACL check is finished. Unlock. */
+	    authenticateAuthUserRequestUnlock(auth_user_request);
+	    return -2;
+	}			/* on 0 the authentication is finished - fallthrough */
+	/* See of user authentication failed for some reason */
+	if (!authenticateUserAuthenticated(auth_user_request)) {
+	    if ((!checklist->rfc931[0]) &&
+		(authenticateUserRequestUsername(auth_user_request))) {
+		if (!checklist->request->auth_user_request) {
+		    /* lock the user for the request structure link */
+		    authenticateAuthUserRequestLock(auth_user_request);
+		    checklist->request->auth_user_request = auth_user_request;
+		}
+	    }
+	    /* this ACL check is finished. Unlock. */
+	    authenticateAuthUserRequestUnlock(auth_user_request);
 #if 0
-            authenticateFreeProxyAuthUser(auth_user_request);
+	    authenticateFreeProxyAuthUser(auth_user_request);
 #endif
-            return -2;
-                
-        }
-    } 
+	    return -2;
+
+	}
+    }
     /* User authenticated ok */
     assert(authenticateUserAuthenticated(auth_user_request));
 #if 0
@@ -1283,59 +1282,58 @@
     /* timeout checking on time_since_last_request is done by the auth framework
      * by not reusing the existing user during decode iff the interval is too long */
     /* conn based auth can't time out during a connection */
-    if ((checklist->conn->auth_user_request) || (auth_user_request->auth_user->expiretime + Config.authenticateTTL > current_time.tv_sec)) 
-    {
-        auth_user_request->auth_user->expiretime = current_time.tv_sec;
-#endif
-
-    /* copy username to request for logging on client-side */
-    /* the credentials are correct at this point */
-    if (!checklist->request->auth_user_request) {
-        /* lock the user for the request structure link */
-        authenticateAuthUserRequestLock(auth_user_request);
-        checklist->request->auth_user_request=auth_user_request;
-    }
-    if (authenticateCheckAuthUserIP(checklist->src_addr, auth_user_request)) {
-        /* Once the match is completed we have finished with the
-         * auth_user structure */
-        /* this ACL check completed */
-        authenticateAuthUserRequestUnlock(auth_user_request);
-        /* check to see if we have matched the user-acl before */
-        return
-            aclCacheMatchAcl(&auth_user_request->auth_user->proxy_match_cache,
-            acltype, data, authenticateUserRequestUsername(auth_user_request));
-    } 
-    /* this acl check completed */
-    authenticateAuthUserRequestUnlock(auth_user_request);
-    return 0;
-#if 0        
+    if ((checklist->conn->auth_user_request) || (auth_user_request->auth_user->expiretime + Config.authenticateTTL > current_time.tv_sec)) {
+	auth_user_request->auth_user->expiretime = current_time.tv_sec;
+#endif
+
+	/* copy username to request for logging on client-side */
+	/* the credentials are correct at this point */
+	if (!checklist->request->auth_user_request) {
+	    /* lock the user for the request structure link */
+	    authenticateAuthUserRequestLock(auth_user_request);
+	    checklist->request->auth_user_request = auth_user_request;
+	}
+	if (authenticateCheckAuthUserIP(checklist->src_addr, auth_user_request)) {
+	    /* Once the match is completed we have finished with the
+	     * auth_user structure */
+	    /* this ACL check completed */
+	    authenticateAuthUserRequestUnlock(auth_user_request);
+	    /* check to see if we have matched the user-acl before */
+	    return
+		aclCacheMatchAcl(&auth_user_request->auth_user->proxy_match_cache,
+		acltype, data, authenticateUserRequestUsername(auth_user_request));
+	}
+	/* this acl check completed */
+	authenticateAuthUserRequestUnlock(auth_user_request);
+	return 0;
+#if 0
     } else {
-        /* timeout */
-        fatalf("user credentials not used for too long in acl.c - currently broken\n"
-               "the timeout values: expire:%d TTL %d expire+TTL %d now %d\n",
-                auth_user_request->auth_user->expiretime,Config.authenticateTTL,
-                 auth_user_request->auth_user->expiretime+ Config.authenticateTTL,
-                 current_time.tv_sec);
-        /* this is broken because it assumes we can retry authentication - for
-           digest/NTLM/kerberos we may not be able to. the Decode process should
-           catch timed out but not garbage collected users anyway - this code
-           _should_ be unreachable */
-        debug(28, 4) ("aclMatchProxyAuth: user '%s' timeout\n",
-            authenticateUserRequestUsername(auth_user_request));
-        /* reset the password check info */
-        auth_user_request->auth_user->flags.credentials_ok = 0;
-        /* now give the checklist this auth_user_request */
-        checklist->auth_user_request = auth_user_request;
-        /* update the TTL so we don't have an infinite loop */
-        auth_user_request->auth_user->expiretime = current_time.tv_sec;
-        /* this ACL check completed */ 
-        authenticateAuthUserRequestUnlock(auth_user_request);
-        /* and trigger the external helper in case the password is still ok */
-        return -1;
-    }
-   /* unreachable code. Spit a debug info and fatal squid out of here */ 
-fatal("acl unreachable code!");
-return -2;
+	/* timeout */
+	fatalf("user credentials not used for too long in acl.c - currently broken\n"
+	    "the timeout values: expire:%d TTL %d expire+TTL %d now %d\n",
+	    auth_user_request->auth_user->expiretime, Config.authenticateTTL,
+	    auth_user_request->auth_user->expiretime + Config.authenticateTTL,
+	    current_time.tv_sec);
+	/* this is broken because it assumes we can retry authentication - for
+	 * digest/NTLM/kerberos we may not be able to. the Decode process should
+	 * catch timed out but not garbage collected users anyway - this code
+	 * _should_ be unreachable */
+	debug(28, 4) ("aclMatchProxyAuth: user '%s' timeout\n",
+	    authenticateUserRequestUsername(auth_user_request));
+	/* reset the password check info */
+	auth_user_request->auth_user->flags.credentials_ok = 0;
+	/* now give the checklist this auth_user_request */
+	checklist->auth_user_request = auth_user_request;
+	/* update the TTL so we don't have an infinite loop */
+	auth_user_request->auth_user->expiretime = current_time.tv_sec;
+	/* this ACL check completed */
+	authenticateAuthUserRequestUnlock(auth_user_request);
+	/* and trigger the external helper in case the password is still ok */
+	return -1;
+    }
+    /* unreachable code. Spit a debug info and fatal squid out of here */
+    fatal("acl unreachable code!");
+    return -2;
 #endif
 }
 
@@ -1343,14 +1341,14 @@
 aclLookupProxyAuthStart(aclCheck_t * checklist)
 {
     auth_user_request_t *auth_user_request;
-    assert(checklist->auth_user_request!=NULL);       /* this is created for us */
+    assert(checklist->auth_user_request != NULL);	/* this is created for us */
     auth_user_request = checklist->auth_user_request;
 
     assert(authenticateValidateUser(auth_user_request));
     authenticateStart(auth_user_request, aclLookupProxyAuthDone, checklist);
 }
 
-    static int
+static int
 aclMatchInteger(intlist * data, int i)
 {
     intlist *first, *prev;
@@ -1609,60 +1607,40 @@
 	if (NULL == r) {
 	    return -1;
 	} else if (!r->flags.accelerated) {
-#if 0
 	    /* Proxy authorization on proxy requests */
-	    header =
-		httpHeaderGetStr(&checklist->request->header,
-		HDR_PROXY_AUTHORIZATION);} else if (r->flags.internal) {
+	    headertype = HDR_PROXY_AUTHORIZATION;
+	} else if (r->flags.internal) {
 	    /* WWW authorization on accelerated internal requests */
-	    header =
-		httpHeaderGetStr(&checklist->request->header,
-		HDR_AUTHORIZATION);} else {
+	    headertype = HDR_AUTHORIZATION;
+	} else {
 #if AUTH_ON_ACCELERATION
 	    /* WWW authorization on accelerated requests */
-	    header =
-		httpHeaderGetStr(&checklist->request->header,
-		HDR_AUTHORIZATION);
-#else
-	    debug(28, 1) ("aclMatchAcl: proxy_auth %s not applicable on accelerated requests.\n",
-		ae->name); return -1;
-#endif
-	}
-#endif
-            /* Proxy authorization on proxy requests */
-            headertype = HDR_PROXY_AUTHORIZATION;
-        } else if (r->flags.internal) {
-            /* WWW authorization on accelerated internal requests */
-            headertype = HDR_AUTHORIZATION;
-        } else {
-#if AUTH_ON_ACCELERATION
-            /* WWW authorization on accelerated requests */
-            headertype = HDR_AUTHORIZATION;
+	    headertype = HDR_AUTHORIZATION;
 #else
-            debug(28, 1) ("aclMatchAcl: proxy_auth %s not applicable on accelerated requests.\n", ae->name);
+	    debug(28, 1) ("aclMatchAcl: proxy_auth %s not applicable on accelerated requests.\n", ae->name);
 	    return -1;
 #endif
-        }
-        /* Check the credentials */
+	}
+	/* Check the credentials */
 	switch (aclMatchProxyAuth(ae->data, headertype,
 		checklist->auth_user_request, checklist, ae->type)) {
 	case 0:
-            debug(28, 4) ("aclMatchAcl: returning  0 user authenticated but not authorised.\n");
+	    debug(28, 4) ("aclMatchAcl: returning  0 user authenticated but not authorised.\n");
 	    /* Authenticated but not Authorised for this ACL */
 	    return 0;
 	case 1:
-            debug(28, 4) ("aclMatchAcl: returning  1 user authenticated and authorised.\n");
+	    debug(28, 4) ("aclMatchAcl: returning  1 user authenticated and authorised.\n");
 	    /* Authenticated and Authorised for this ACL */
 	    return 1;
 	case -2:
-            debug(28, 4) ("aclMatchAcl: returning 0 sending authentication challenge.\n");
+	    debug(28, 4) ("aclMatchAcl: returning 0 sending authentication challenge.\n");
 	    /* Authentication credentials invalid or missing. */
-            /* Or partway through NTLM handshake. A proxy_Authenticate header
-             * gets sent to the client. */
+	    /* Or partway through NTLM handshake. A proxy_Authenticate header
+	     * gets sent to the client. */
 	    checklist->state[ACL_PROXY_AUTH] = ACL_PROXY_AUTH_NEEDED;
 	    return 0;
 	case -1:
-            debug(28, 4) ("aclMatchAcl: returning 0 sending credentials to helper.\n");
+	    debug(28, 4) ("aclMatchAcl: returning 0 sending credentials to helper.\n");
 	    /*
 	     * we need to validate the password
 	     */
@@ -1793,15 +1771,13 @@
 		aclLookupDstFQDNDone,
 		checklist);
 	    return;
-	}
-	else if (checklist->state[ACL_PROXY_AUTH] == ACL_LOOKUP_NEEDED) {
+	} else if (checklist->state[ACL_PROXY_AUTH] == ACL_LOOKUP_NEEDED) {
 	    debug(28, 3)
 		("aclCheck: checking password via authenticator\n");
 	    aclLookupProxyAuthStart(checklist);
 	    checklist->state[ACL_PROXY_AUTH] = ACL_LOOKUP_PENDING;
 	    return;
-	}
-	else if (checklist->state[ACL_PROXY_AUTH] == ACL_PROXY_AUTH_NEEDED) {
+	} else if (checklist->state[ACL_PROXY_AUTH] == ACL_PROXY_AUTH_NEEDED) {
 	    /* Client is required to resend the request with correct authentication
 	     * credentials. (This may be part of a stateful auth protocol.
 	     * The request is denied.
@@ -1941,20 +1917,19 @@
     auth_user_request_t *auth_user_request;
     checklist->state[ACL_PROXY_AUTH] = ACL_LOOKUP_DONE;
     if (result != NULL)
-        fatal("AclLookupProxyAuthDone: Old code floating around somewhere.\nMake clean and if that doesn't work, report a bug to the squid developers.\n");
+	fatal("AclLookupProxyAuthDone: Old code floating around somewhere.\nMake clean and if that doesn't work, report a bug to the squid developers.\n");
     /* state info check */
     assert(checklist->conn != NULL);
     auth_user_request = checklist->auth_user_request;
-    if (!authenticateValidateUser(auth_user_request))
-    {
-        /* credentials could not be checked either way
-         * restart the whole process */
-        checklist->conn->auth_user_request = NULL;
-        checklist->conn->auth_type = AUTH_BROKEN;
-        checklist->auth_user_request = NULL;
-        authenticateAuthUserRequestUnlock(auth_user_request);
-        aclCheck(checklist);
-        return;
+    if (!authenticateValidateUser(auth_user_request)) {
+	/* credentials could not be checked either way
+	 * restart the whole process */
+	checklist->conn->auth_user_request = NULL;
+	checklist->conn->auth_type = AUTH_BROKEN;
+	checklist->auth_user_request = NULL;
+	authenticateAuthUserRequestUnlock(auth_user_request);
+	aclCheck(checklist);
+	return;
     }
     aclCheck(checklist);
 }
@@ -1966,11 +1941,11 @@
     aclCheck_t *checklist = data;
     checklist->state[ACL_PROXY_AUTH] = ACL_LOOKUP_DONE;
     debug(28, 4) ("aclLookupProxyAuthDone: result = %s\n",
-        result ? result : "NULL");
+	result ? result : "NULL");
     if (result && (strncasecmp(result, "OK", 2) == 0))
-        checklist->auth_user->flags.credentials_ok = 1;
+	checklist->auth_user->flags.credentials_ok = 1;
     else
-        checklist->auth_user->flags.credentials_ok = 2;
+	checklist->auth_user->flags.credentials_ok = 2;
     aclCheck(checklist);
 }
 #endif
@@ -2685,7 +2660,8 @@
 	/* Return if match, otherwise continue to other interfaces */
 	if (0 == splayLastResult) {
 	    debug(28, 3) ("aclMatchArp: %s found on %s\n",
-		inet_ntoa(c), ifr->ifr_name); return 1;
+		inet_ntoa(c), ifr->ifr_name);
+	    return 1;
 	}
 	/*
 	 * Should we stop looking here? Can the same IP address
